<template>
  <div class="chart" :id="id"></div>
</template>

<script>
import util from "@/helper/util.js";
import partten from "@/helper/partten.js";
import * as echarts from "echarts";

export default {
  name: "double-line-chart",
  componentName: "double-line-chart",
  props: {
    width: {
      type: String,
      default: "100%",
    },
    height: {
      type: String,
      default: "13.889vh",
    },
    // 传入数据
    list: {
      type: Array,
      default: () => [
        {
          title: "绿线",
          value: [
            {
              text: "",
              value: 0,
            },
            {
              text: "0:00",
              value: 20,
            },
            {
              text: "10:00",
              value: 1,
            },
            {
              text: "11:00",
              value: 40,
            },
            {
              text: "12:00",
              value: 10,
            },
            {
              text: "13:00",
              value: 15,
            },
            {
              text: "14:00",
              value: 30,
            },
            {
              text: "15:00",
              value: 40,
            },
            {
              text: "",
              value: 10,
            },
          ],
        },
        {
          title: "黄线",
          value: [
            {
              text: "",
              value: 0,
            },
            {
              text: "0:00",
              value: 40,
            },
            {
              text: "10:00",
              value: 20,
            },
            {
              text: "11:00",
              value: 20,
            },
            {
              text: "12:00",
              value: 10,
            },
            {
              text: "13:00",
              value: 40,
            },
            {
              text: "14:00",
              value: 50,
            },
            {
              text: "15:00",
              value: 40,
            },
            {
              text: "",
              value: 10,
            },
          ],
        },
      ],
    },
    // 单位
    unit: {
      type: String,
      default: "",
    },
  },
  data () {
    return {
      id: "",
      chart: null,
      color: ["#05bb4c", "#f8de5b", "#4b55ae", "#fa8c16"],
    };
  },
  computed: {
    colorValue () {
      return partten.getColor(this.color);
    },
    datas () {
      return this.list.map((t) => {
        return t.value;
      });
    },
    xdata () {
      return this.list[0].value.map((t) => {
        return t.text;
      });
    },
    series () {
      let result = [];

      this.list.forEach((value, index) => {
        result.push({
          name: value.title,
          type: "line",
          smooth: true,
          showSymbol: false,
          zlevel: index,
          lineStyle: {
            normal: {
              color: this.color[index],
            },
          },
          yAxisIndex: value.yAxisIndex,
          data: value.value.map((t) => {
            return t.value;
          }),
        });
      });

      return result;
    },
    yAxis () {
      let result = [];
      result.push({
        type: "value",
        name: this.unit,
        axisLabel: {
          formatter: "{value}",
          fontSize: util.vh(14),
        },
        boundaryGap: false,
        //分格线
        splitLine: {
          show: false,
        },
      });
      return result;
    },
  },
  methods: {
    hexToRgba (hex, opacity) {
      let rgbaColor = "";
      let reg = /^#[\da-f]{6}$/i;
      if (reg.test(hex)) {
        rgbaColor = `rgba(${parseInt("0x" + hex.slice(1, 3))},${parseInt("0x" + hex.slice(3, 5))},${parseInt("0x" + hex.slice(5, 7))},${opacity})`;
      }
      return rgbaColor;
    },
    initChart () {
      let option = {
        color: this.color,
        tooltip: {
          trigger: "item",
          backgroundColor: "rgba(255,255,255,0.3)",
          textStyle: {
            color: "#fff",
            fontSize: util.vh(16),
          },
          formatter: function (param) {
            console.log(param);
            return param.name + "<br >" + param.marker + param.seriesName + "：" + param.value;
          },
        },
        grid: {
          top: 20,
          left: 30,
          right: 20,
          bottom: 40,
        },
        xAxis: [
          {
            type: "category",
            boundaryGap: false,
            axisLabel: {
              formatter: "{value}",
              textStyle: {
                color: "#333",
                fontSize: util.vh(14),
              },
            },
            data: this.xdata,
          },
        ],
        yAxis: this.yAxis,
        series: this.series,
      };

      this.chart.setOption(option);
    },
  },
  created () {
    this.id = "pie-chart-" + util.newGUID();
  },
  mounted () {
    this.$nextTick(() => {
      this.$el.style.width = this.width;
      this.$el.style.height = this.height;
      this.chart = echarts.init(this.$el);
      this.initChart();
    });
  },
  updated () {
    this.initChart();
  },
};
</script>

<style lang="less">
.chart {
  width: 100%;
  height: 100%;
  display: inline-block;
}
</style>
